VERSION 5.00
Begin VB.Form frmAnalize 
   Caption         =   "XML Analysis"
   ClientHeight    =   6465
   ClientLeft      =   4005
   ClientTop       =   4635
   ClientWidth     =   7770
   Icon            =   "frmAnalize.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6465
   ScaleWidth      =   7770
   Begin VB.Frame Frame2 
      Caption         =   "Method Call"
      Height          =   1455
      Left            =   120
      TabIndex        =   12
      Top             =   2040
      Width           =   7455
      Begin VB.Label LabelMethodCall 
         Caption         =   "Label5"
         Height          =   855
         Left            =   120
         TabIndex        =   13
         Top             =   360
         Width           =   7215
      End
   End
   Begin VB.CommandButton cmdViewNewXML 
      Caption         =   "View New XML for this Component Type"
      Height          =   375
      Left            =   240
      TabIndex        =   11
      Top             =   5880
      Width           =   3735
   End
   Begin VB.ComboBox ComboDefaultList 
      Height          =   315
      Left            =   2400
      TabIndex        =   10
      Top             =   4200
      Width           =   5175
   End
   Begin VB.Frame Frame1 
      Caption         =   "Analysis Information"
      Height          =   1695
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   7455
      Begin VB.Label LabelCurrentInfo 
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   1080
         Width           =   7215
      End
      Begin VB.Label Label4 
         Caption         =   $"frmAnalize.frx":0442
         Height          =   615
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Width           =   6735
      End
   End
   Begin VB.ComboBox ComboTemplateOps1 
      Height          =   315
      Left            =   2400
      TabIndex        =   3
      Top             =   4680
      Width           =   5175
   End
   Begin VB.ComboBox ComboProfile 
      Height          =   315
      Left            =   2400
      TabIndex        =   2
      Top             =   3720
      Width           =   5175
   End
   Begin VB.CommandButton cmdViewCurrentXML 
      Caption         =   "View Current Components XML"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   5280
      Width           =   3735
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   495
      Left            =   6000
      TabIndex        =   0
      Top             =   5760
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Template Options"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   4800
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Available Defaults"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   4320
      Width           =   1695
   End
   Begin VB.Label Label1 
      Caption         =   "Available Profiles"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   3840
      Width           =   1575
   End
End
Attribute VB_Name = "frmAnalize"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public m_strComponentID As String
Public m_strViewID As String
Public m_strComponentDefID As String

Private m_nComponentDefID As Long

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub cmdViewCurrentXML_Click()
On Error GoTo errHandler
    Dim strXML As String
    Dim strMthdCll As String
    Dim nProfileID As Long
    Dim nOptions As Integer
    nProfileID = ComboProfile.ItemData(ComboProfile.ListIndex)
    nOptions = ComboTemplateOps1.ItemData(ComboTemplateOps1.ListIndex)
    If m_nComponentDefID < 0 Then
        strXML = g_objTemplateController.getSystemComponent(m_nComponentDefID, m_strComponentID, nProfileID, nOptions)
        strMthdCll = "getFilePlanComponent(" & m_nComponentDefID & ", " & m_strComponentID & ", " & nProfileID & ", " & nOptions & ")"
    Else
        strXML = g_objTemplateController.getFilePlanComponent(m_strComponentID, nProfileID, nOptions)
        strMthdCll = "getFilePlanComponent(" & m_strComponentID & ", " & nProfileID & ", " & nOptions & ")"
    End If
    
    LabelMethodCall.Caption = strMthdCll
    
    DisplayXML strXML, strMthdCll & " Option: " & ComboTemplateOps1.Text
Exit Sub
errHandler:
    If HandleError Then Resume
End Sub

Private Sub cmdViewNewXML_Click()
On Error GoTo errHandler
    Dim strXML As String
    Dim strMthdCll As String
    Dim nProfileID As Long
    Dim nOptions As Integer
    Dim nDefaultID As Long
    nProfileID = ComboProfile.ItemData(ComboProfile.ListIndex)
    nOptions = ComboTemplateOps1.ItemData(ComboTemplateOps1.ListIndex)
    nDefaultID = ComboDefaultList.ItemData(ComboDefaultList.ListIndex)
    strXML = g_objTemplateController.getNewComponent(m_nComponentDefID, _
                                                    nProfileID, _
                                                    nDefaultID, _
                                                    nOptions)
                                                    
    strMthdCll = "getNewComponent(" & m_nComponentDefID & ", " & nProfileID & ", " & nDefaultID & ", " & nOptions & ")"
    LabelMethodCall.Caption = strMthdCll

    DisplayXML strXML, strMthdCll & " Option: " & ComboTemplateOps1.Text
Exit Sub
errHandler:
    If HandleError Then Resume
End Sub

Private Sub Form_Load()
    
On Error GoTo errHandler

    Dim i As Long
    
    Dim objDom As DOMDocument
    Dim objItem As IXMLDOMElement
    Dim strXML As String
    
    m_nComponentDefID = CLng(m_strComponentDefID)
    
    Set objDom = New DOMDocument
    
    LabelCurrentInfo.Caption = "Current File Plan Component ID: " & m_strComponentID & " ComponentDefID: " & m_strComponentDefID & " View ID: " & m_strViewID
   
    ComboTemplateOps1.AddItem "NONE", 0
    ComboTemplateOps1.ItemData(0) = 0
    ComboTemplateOps1.AddItem "EXPAND_LISTS", 1
    ComboTemplateOps1.ItemData(1) = 1
    ComboTemplateOps1.AddItem "PROFILE_FIELDS", 2
    ComboTemplateOps1.ItemData(2) = 2
    ComboTemplateOps1.AddItem "EXPAND_LISTS_AND_PROFILE_FIELDS", 3
    ComboTemplateOps1.ItemData(3) = 3
    ComboTemplateOps1.ListIndex = 0
    
    'Load the available Defaults for the current Component
    i = 0
    strXML = g_objComponentDesignController.getDefaultListForUserGroup(g_strCurrentUserID, m_strComponentDefID)
    If objDom.LoadXml(strXML) Then
        ComboDefaultList.AddItem "NONE", i
        ComboDefaultList.ItemData(i) = 0
        i = i + 1
        For Each objItem In objDom.selectNodes("List/Item")
            ComboDefaultList.AddItem objItem.getAttribute("FlPlnCmpntDfltNm"), i
            ComboDefaultList.ItemData(i) = CLng(objItem.getAttribute("FlPlnCmpntDfltID"))
            i = i + 1
        Next
        ComboDefaultList.ListIndex = 0
    Else
        MsgBox "FAILED to load DefaultListForUserGroup " & objDom.parseError.reason
    End If

    'Load the available Profiles for the current Component
    i = 0
    strXML = g_objComponentDesignController.getProfileListForUserGroup(g_strCurrentUserID, m_strComponentDefID)
    If objDom.LoadXml(strXML) Then
        ComboProfile.AddItem "NONE", i
        ComboProfile.ItemData(i) = 0
        i = i + 1
        For Each objItem In objDom.selectNodes("List/Item")
            ComboProfile.AddItem objItem.getAttribute("FlPlnCmpntPrflDefNm"), i
            ComboProfile.ItemData(i) = CLng(objItem.getAttribute("FlPlnCmpntPrflDefID"))
            i = i + 1
        Next
        ComboProfile.ListIndex = 0
    Else
        MsgBox "FAILED to load ProfileListForUserGroup " & objDom.parseError.reason
    End If

Exit Sub

errHandler:
    If HandleError Then Resume
End Sub
