VERSION 5.00
Begin VB.Form frmListPicker 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Dialog Caption"
   ClientHeight    =   8325
   ClientLeft      =   3495
   ClientTop       =   3225
   ClientWidth     =   6645
   Icon            =   "frmListPicker.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   8325
   ScaleWidth      =   6645
   ShowInTaskbar   =   0   'False
   Begin VB.ListBox List1 
      Height          =   6885
      Left            =   270
      TabIndex        =   2
      Top             =   270
      Width           =   6195
   End
   Begin VB.CommandButton cmdViewContentList 
      Caption         =   "View XML"
      Height          =   375
      Left            =   3780
      TabIndex        =   1
      Top             =   7740
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   5220
      TabIndex        =   0
      Top             =   7740
      Width           =   1215
   End
End
Attribute VB_Name = "frmListPicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Public m_strFilePlanComponentID As String

Private m_strXML As String
Private m_objDom As DOMDocument
Private m_objNodeList As IXMLDOMNodeList

Private Sub cmdViewContentList_Click()
    DisplayXML m_strXML, "Content List XML"
End Sub

Private Sub List1_DblClick()
    
    Dim strChunk As String
    Dim strContent As String
    Dim nContentID As Long
    Const chunkSize = 1000
    nContentID = List1.ItemData(List1.ListIndex)
    
    Dim nStreamID 'As Long ' Very Long
    nStreamID = g_objFilePlanComponentController.openContentStreamForRead(m_strFilePlanComponentID, nContentID)
    Do
        strChunk = g_objFilePlanComponentController.readContentStream(nStreamID, chunkSize)
        strContent = strContent & strChunk
    Loop While (Len(strChunk) >= chunkSize)
    g_objFilePlanComponentController.closeContentStream nStreamID
    
    Dim obDom As New DOMDocument
    Dim root As IXMLDOMElement
    Set root = obDom.createElement("root")
    obDom.appendChild root
    root.dataType = "bin.base64"
    root.nodeTypedValue = strContent
    
    DisplayXML obDom.xml, "Content"
    'DisplayXML strContent, "Record Content"
    
End Sub

Private Sub OKButton_Click()
    Unload Me
End Sub

Private Sub Form_Load()
On Error GoTo errHandler
    
    m_strXML = g_objFilePlanComponentController.getContentList(m_strFilePlanComponentID)
    
    Set m_objDom = New DOMDocument
    m_objDom.async = False
    If m_objDom.LoadXml(m_strXML) Then
        Set m_objNodeList = m_objDom.selectNodes("List/Item")
        Dim objItem As IXMLDOMElement
        Dim i As Integer
        Dim strContentName As String
        Dim nContentID As Long
        For i = 0 To m_objNodeList.length - 1
            Set objItem = m_objNodeList(i)
            strContentName = objItem.getAttribute("ContentName")
            nContentID = CLng(objItem.getAttribute("ContentID"))
            List1.AddItem strContentName, i
            List1.ItemData(i) = nContentID
        Next i
    Else
        MsgBox m_objDom.parseError.reason
    End If
    
Exit Sub
errHandler:
    If HandleError Then Resume
End Sub
