Attribute VB_Name = "Module1"
Option Explicit

'Profile Actions
Global Const VIEW = 0
Global Const ADD = 1
Global Const UPDATE = 2

'com.ibm.gre.engine.util.HostUserSource
Global Const IN_BOTH = 3
Global Const IN_RECORD_MANAGER = 1
Global Const NOT_IN_RECORD_MANAGER = 2

'com.ibm.gre.engine.util.FilePlanComponentTypes
Global Const COMPONENT = "1"
Global Const RECORD = "2"

'com.ibm.gre.engine.util.QueryResultOptions
Global Const COUNT_ONLY = 1
Global Const INCLUDE_COLUMNS = 2
Global Const NORMAL = 0

'com.ibm.gre.engine.util.TemplateOptions
Global Const NONE = 0
Global Const EXPAND_LISTS = 1
Global Const PROFILE_FIELDS = 2
Global Const EXPAND_LISTS_AND_PROFILE_FIELDS = 3

'com.ibm.gre.engine.util.AttributeDataTypes
Global Const CONST_BINARY = 7
Global Const CONST_BOOLEAN = 1
Global Const CONST_CLOB = 9
Global Const CONST_DATE = 3
Global Const CONST_DATETIME = 10
Global Const CONST_DOUBLE = 4
Global Const CONST_INTEGER = 5
Global Const CONST_STRING = 6

'com.ibm.gre.engine.util.ComponentDefinitionTypes
Global Const ATTRIBUTE_DEFINITION = -2
Global Const AUDIT_ENTRY = -17
Global Const AUTO_CLASSIFY_RULE = -21
Global Const CHARGE_OUT = -20
Global Const CHARGE_OUT_HISTORY = -25
Global Const DEFAULT = -6
Global Const DISPOSAL_AUTHORITY = -15
Global Const FILE_PLAN_COMPONENT = 0
Global Const FILE_PLAN_COMPONENT_DEFINITION = -1
Global Const FILE_PLAN_VIEW = -13
Global Const GROUP = -4
Global Const HOST = -12
Global Const LIFE_CYCLE_CODE = -10
Global Const LIFE_CYCLE_CODE_PHASE = -18
Global Const LIFE_CYCLE_PHASE = -9
Global Const LOGIC_EXTENSION = -8
Global Const PROFILE = -16
Global Const RELATIONSHIP_DEFINITION = -5
Global Const REPORT_LAYOUT = -23
Global Const RESERVATION = -19
Global Const ROLE = -26
Global Const SAVED_QUERY = -24
Global Const SUSPENSION = -14
Global Const USER = -3

'com.ibm.gre.engine.util.ProfileControlType
Global Const SINGLELINE = 1
Global Const MULTILINE = 2
Global Const LINESEPERATOR = 3
Global Const BLANKLINE = 4
Global Const GROUPBEGIN = 5
Global Const GROUPEND = 6
Global Const USERFIELD = 7
Global Const DROPLIST = 8 ' new for 3.1
Global Const COMBOBOX = 9 ' new for 3.1

Global Const WSDL_FILE_PATH = "/wsdl/com/ibm/gre/engine/ejb/facade"

'Low Level API constants
Global Const CONNECTION_ERROR = 1 + vbObjectError + 512
Global Const SOAP_ERROR = 2 + vbObjectError + 512
Global Const ENCODING_STYLE = "http://schemas.xmlsoap.org/soap/encoding/"
Global Const XSI = "http://www.w3.org/1999/XMLSchema-instance"
Global Const XSD = "http://www.w3.org/2001/XMLSchema"
Global Const LOGIN_MANAGER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.LoginManagerEJB"
Global Const CLIENT_CONTROLLER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.ClientControllerEJB"
Global Const COMPONENT_DESIGN_CONTROLLER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.ComponentDesignControllerEJB"
Global Const CONFIGURATION_CONTROLLER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.ConfigurationControllerEJB"
Global Const USER_CONTROLLER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.UserControllerEJB"
Global Const DEFINITION_CONTROLLER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.DefinitionControllerEJB"
Global Const FILE_PLAN_DESIGN_CONTROLLER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.FilePlanDesignControllerEJB"
Global Const FILE_PLAN_COMPONENT_CONTROLLER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.FilePlanComponentControllerEJB"
Global Const LIFE_CYCLE_DESIGN_CONTROLLER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.LifeCycleDesignControllerEJB"
Global Const RECORDS_OPERATIONS_CONTROLLER_EJB = "http://ibm.com/com.ibm.gre.engine.ejb.facade.RecordsOperationsControllerEJB"

Global Const PROFILE_FORM_DIMENSIONS = "PROFILE_FORM_DIMENSIONS"
Global Const VERT_CONTROL_SPACING = 55

Global Const g_left = 3773
Global Const g_top = 45
Global Const g_datPlus = 40

Global Const LOGIN_CANCEL = 0
Global Const LOGIN_OK = 1
Global Const LOGIN_BAD_WEB_SERVICE_LOCATION = 2
Global Const DISABLE_ENGINE = 99

'Image Ids
Global Const IMG_BOOKS_CLOSED = 1
Global Const IMG_BOOKS_OPEN = 2
Global Const IMG_BOOK_CLOSED = 3
Global Const IMG_BOOK_OPEN = 4
Global Const IMG_INTERFACE_CLOSED = 5
Global Const IMG_INTERFACE_OPEN = 6
Global Const IMG_FOLDERS_CLOSED = 7
Global Const IMG_FOLDERS_OPEN = 8
Global Const IMG_FOLDER_CLOSED = 9
Global Const IMG_FOLDER_OPEN = 10
Global Const IMG_USER_CLOSED = 11
Global Const IMG_USER_OPEN = 12
Global Const IMG_GROUP_CLOSED = 13
Global Const IMG_GROUP_OPEN = 14
Global Const IMG_HOST_CLOSED = 15
Global Const IMG_HOST_OPEN = 16
Global Const IMG_FILE_PLAN_CLOSED = 17
Global Const IMG_FILE_PLAN_OPEN = 18
Global Const IMG_QUERIES_CLOSED = 19
Global Const IMG_QUERIES_OPEN = 20
Global Const IMG_QUERY_CLOSED = 21
Global Const IMG_QUERY_OPEN = 22
Global Const IMG_API_CLOSED = 23
Global Const IMG_API_OPEN = 24
Global Const IMG_VIEW_CLOSED = 25
Global Const IMG_VIEW_OPEN = 26
Global Const IMG_CONTENT_CLOSED = 27
Global Const IMG_CONTENT_OPEN = 28


Global Const LISTVIEW_MODE0 = "View Large Icons"
Global Const LISTVIEW_MODE1 = "View Small Icons"
Global Const LISTVIEW_MODE2 = "View List"
Global Const LISTVIEW_MODE3 = "View Details"

'Global variables

Public g_strTrace As String
Public g_bOk As Boolean

Public g_strTempXMLFile As String
Public g_nNodeKey As Long

Public fMainForm As frmMain

Public g_strWebServiceLocation As String ' Default Location = "http://localhost:9080/IRMWebServices/wsdl/com/ibm/gre/engine/ejb/facade"

'Save login values for timeout handling
Public g_strUserName As String
Public g_strPassword As String
Public g_strDatabase As String
Public g_strHostName As String
Public g_strLanguage As String

Private m_objLoginManager As SoapClient30

'Serialized Remote Interfaces for Controller objects
'NOTE once a controller is created it is most efficient maintain a reference to that object for re-use

'LoginManager
Public g_strEngineVersion As String

'The ClientController object creates all other controllers
Public g_strClientControllerKey As String
Public g_objClientController As SoapClient30
Public g_objClientControllerHeaderHandler As SoapHeaderHandler.clsHeaderHandler

'Controller SoapClient30 objects
Public g_objBatchController As SoapClient30
Public g_objComponentDesignController As SoapClient30
Public g_objConfigurationController As SoapClient30
Public g_objDefinitionController As SoapClient30
Public g_objFilePlanComponentController As SoapClient30
Public g_objFilePlanDesignController As SoapClient30
Public g_objLifeCycleDesignController As SoapClient30
Public g_objQueryController As SoapClient30
Public g_objRecordsOperationsController As SoapClient30
Public g_objTemplateController As SoapClient30
Public g_objToolsController As SoapClient30
Public g_objUserController As SoapClient30

'EJBKeys (for low level API)
Public g_strBatchController As String
Public g_strComponentDesignController As String
Public g_strConfigurationController As String
Public g_strDefinitionController As String
Public g_strFilePlanComponentController As String
Public g_strFilePlanDesignController As String
Public g_strLifeCycleDesignController As String
Public g_strQueryController As String
Public g_strRecordsOperationsController As String
Public g_strTemplateController As String
Public g_strToolsController As String
Public g_strUserController As String

Public g_strCurrentUserID As String

Sub Main()

On Error GoTo errHandler
    Dim strDebug As String
    Dim fLogin As New frmLogin
    
    g_bOk = True
    g_nNodeKey = 0 'Initialize TreeView Node Index - this is just used to maintain a unique value for each treeview node
    
    g_strTempXMLFile = App.Path & "\Temp.xml"
    
    Dim str As String
    str = "No" '"DisableEngine"
    If str = "DisableEngine" Then
        
        g_bOk = False
        Set fMainForm = New frmMain
        fMainForm.Show
    
    Else
    
        fLogin.Show vbModal
        
        Select Case fLogin.m_nStatus
            
            Case LOGIN_CANCEL
                End
            Case LOGIN_OK
                
                Unload fLogin
                Dim strTemp As String
                
                'Initialize ClientControllerEJB SoapClient
                g_strTrace = "InitClientController"
                InitClientController
                
                'Now get the rest of the Controllers
                g_strTrace = "InitControllers"
                InitControllers
                
                Set fMainForm = New frmMain
                fMainForm.Show
            Case LOGIN_BAD_WEB_SERVICE_LOCATION
                End
        End Select
    End If
Exit Sub
errHandler:
    If HandleError(g_strTrace) Then Resume
End Sub

Public Sub InitLoginManager()
    
    'Initialize the LoginManager Service
    g_strTrace = "CreateObject(""MSSOAP.SoapClient30"")"
    Set m_objLoginManager = CreateObject("MSSOAP.SoapClient30")
    g_strTrace = "m_objLoginManager.MSSoapInit " & g_strWebServiceLocation & WSDL_FILE_PATH & "/LoginManagerEJBService.wsdl"", ""LoginManagerEJBService"""
    m_objLoginManager.MSSoapInit g_strWebServiceLocation & WSDL_FILE_PATH & "/LoginManagerEJBService.wsdl", "LoginManagerEJBService"

End Sub

Public Function GetDataSourceList() As String
    g_strTrace = "m_objLoginManager.GetDataSourceList()"
    GetDataSourceList = m_objLoginManager.GetDataSourceList()
End Function
    
Public Sub Login()
    
    'Need to specifically set the empty string because SOAP does not understand empty variant
    If Len(g_strHostName) = 0 Then
        g_strHostName = ""
    End If
    
    'Log in to selected database and save the key to the ClientController
    g_strClientControllerKey = m_objLoginManager.integrationLogin(g_strUserName, _
                                                                  g_strPassword, _
                                                                  g_strDatabase, _
                                                                  g_strHostName, _
                                                                  g_strLanguage)
    
    'Save the engine version
    g_strEngineVersion = m_objLoginManager.getEngineVersion()

End Sub
    
Public Sub InitClientController()
    'Initialize ClientControllerEJB SoapClient
    g_strTrace = "g_objClientControllerHeaderHandler = New SoapHeaderHandler.clsHeaderHandler"
    Set g_objClientControllerHeaderHandler = New SoapHeaderHandler.clsHeaderHandler
    g_strTrace = "g_objClientControllerHeaderHandler.EJBKey = " & g_strClientControllerKey
    g_objClientControllerHeaderHandler.EJBKey = g_strClientControllerKey
    
    g_strTrace = "Set g_objClientController = New SoapClient30"
    Set g_objClientController = New SoapClient30
    g_strTrace = "g_objClientController.MSSoapInit" & g_strWebServiceLocation & WSDL_FILE_PATH & "/ClientControllerEJBService.wsdl"", ""ClientControllerEJBService"""
    g_objClientController.MSSoapInit g_strWebServiceLocation & WSDL_FILE_PATH & "/ClientControllerEJBService.wsdl", "ClientControllerEJBService"
    g_strTrace = "Set g_objClientController.HeaderHandler = g_objClientControllerHeaderHandler"
    Set g_objClientController.HeaderHandler = g_objClientControllerHeaderHandler
End Sub
            
Public Sub InitControllers()
    'Now get the rest of the Controllers
    Set g_objBatchController = GetSoapClient(g_objClientController, "BatchController")
    Set g_objComponentDesignController = GetSoapClient(g_objClientController, "ComponentDesignController")
    Set g_objConfigurationController = GetSoapClient(g_objClientController, "ConfigurationController")
    Set g_objDefinitionController = GetSoapClient(g_objClientController, "DefinitionController")
    Set g_objFilePlanComponentController = GetSoapClient(g_objClientController, "FilePlanComponentController")
    Set g_objFilePlanDesignController = GetSoapClient(g_objClientController, "FilePlanDesignController")
    Set g_objLifeCycleDesignController = GetSoapClient(g_objClientController, "LifeCycleDesignController")
    Set g_objQueryController = GetSoapClient(g_objClientController, "QueryController")
    Set g_objRecordsOperationsController = GetSoapClient(g_objClientController, "RecordsOperationsController")
    Set g_objTemplateController = GetSoapClient(g_objClientController, "TemplateController")
    Set g_objToolsController = GetSoapClient(g_objClientController, "ToolsController")
    Set g_objUserController = GetSoapClient(g_objClientController, "UserController")
    g_strCurrentUserID = g_objUserController.getUserId()
End Sub

Public Function GetSoapClient(objClientController As SoapClient30, ByVal strControllerName As String) As SoapClient30

    Dim strTemp As String
    Dim objSoapClient30 As SoapClient30
    Dim objSoapHeaderHandler As SoapHeaderHandler.clsHeaderHandler
    
    Select Case strControllerName
        
        Case "BatchController"
            strTemp = objClientController.getBatchControllerAsString()
            g_strBatchController = strTemp
            
        Case "ComponentDesignController"
            strTemp = objClientController.getComponentDesignControllerAsString()
            g_strComponentDesignController = strTemp
            
        Case "ConfigurationController"
            strTemp = objClientController.getConfigurationControllerAsString()
            g_strConfigurationController = strTemp
            
        Case "DefinitionController"
            strTemp = objClientController.getDefinitionControllerAsString()
            g_strDefinitionController = strTemp
        
        Case "FilePlanComponentController"
            strTemp = objClientController.getFilePlanComponentControllerAsString()
            g_strFilePlanComponentController = strTemp
             
        Case "FilePlanDesignController"
            strTemp = objClientController.getFilePlanDesignControllerAsString()
            g_strFilePlanDesignController = strTemp

        Case "LifeCycleDesignController"
            strTemp = objClientController.getLifeCycleDesignControllerAsString()
            g_strLifeCycleDesignController = strTemp
        
        Case "QueryController"
            strTemp = objClientController.getQueryControllerAsString()
            g_strQueryController = strTemp
        
        Case "RecordsOperationsController"
            strTemp = objClientController.getRecordsOperationsControllerAsString()
            g_strRecordsOperationsController = strTemp
        
        Case "TemplateController"
            strTemp = objClientController.getTemplateControllerAsString()
            g_strTemplateController = strTemp
        
        Case "ToolsController"
            strTemp = objClientController.getToolsControllerAsString()
            g_strToolsController = strTemp
        
        Case "UserController"
            strTemp = objClientController.getUserControllerAsString()
            g_strUserController = strTemp
        
    End Select
    
    Set objSoapHeaderHandler = New SoapHeaderHandler.clsHeaderHandler
    objSoapHeaderHandler.EJBKey = strTemp
    
    Set objSoapClient30 = New SoapClient30
    objSoapClient30.MSSoapInit g_strWebServiceLocation & WSDL_FILE_PATH & "/" & strControllerName & "EJBService.wsdl", strControllerName & "EJBService"
    Set objSoapClient30.HeaderHandler = objSoapHeaderHandler
    
    Set GetSoapClient = objSoapClient30

End Function

Public Sub ReLogin()
    
On Error GoTo errHandler
    
    'Login useing saved values
    Login
    
    'Initialize ClientControllerEJB SoapClient
    InitClientController
            
    'Now get the rest of the Controllers
    InitControllers
    
Exit Sub
errHandler:
    If HandleError Then Resume
End Sub

Public Function HandleError(Optional ByVal strComments As String = "") As Boolean
    
    HandleError = False
    Select Case Err.Number
        Case -2147467259
            If InStr(1, Err.Description, "SessionBeanTimeoutException") Then
                If MsgBox("Your Session has Timed out! Push OK to re-login", vbExclamation + vbOKCancel) = vbOK Then
                    ReLogin
                    HandleError = True
                End If
            End If
        Case Else
            If InStr(1, Err.Description, "SessionBeanTimeoutException") Then
                If MsgBox("Your Session has Timed out! Push OK to re-login", vbExclamation + vbOKCancel) = vbOK Then
                    ReLogin
                    HandleError = True
                End If
            End If
    End Select
    
    If HandleError Then Exit Function
    
    Beep
    
    Dim objTempDom As DOMDocument
    Set objTempDom = New DOMDocument
    If Not objTempDom.LoadXml(Err.Description) Then
        Dim objElem As IXMLDOMElement
        Set objElem = objTempDom.createElement("SytemError")
        objElem.Text = Err.Description
        objTempDom.appendChild objElem
    End If
    
    Dim objRoot As IXMLDOMElement
    Dim objErrDescription As IXMLDOMElement
    Dim objErrNumber As IXMLDOMElement
    Dim objErrSource As IXMLDOMElement
    
    Dim objDom As DOMDocument
    Set objDom = New DOMDocument
    
    Set objRoot = objDom.createElement("Error")
        
    If strComments <> "" Then
        Dim objComments As IXMLDOMElement
        Set objComments = objDom.createElement("Comments")
        objComments.Text = strComments
        objRoot.appendChild objComments
    End If
    
    Set objErrDescription = objDom.createElement("Description")
    objErrDescription.appendChild objTempDom.documentElement
    objRoot.appendChild objErrDescription
    
    Set objErrNumber = objDom.createElement("Number")
    objErrNumber.Text = Err.Number
    objRoot.appendChild objErrNumber
    
    Set objErrSource = objDom.createElement("Source")
    objErrSource.Text = Err.Source
    objRoot.appendChild objErrSource
    
    objDom.appendChild objRoot
    
    Dim frm As New frmXReport
    frm.m_bUsePath = False
    frm.m_strXML = objDom.xml
    frm.m_strPath = g_strTempXMLFile
    frm.Caption = "ERROR"
    frm.Show vbModal
    
End Function

Public Sub DisplayXML(ByVal strXML As String, ByVal strCaption As String, Optional ByVal style As Integer = vbModeless)
    Dim frm As New frmXReport
    frm.m_bUsePath = False
    frm.m_strXML = strXML
    frm.m_strPath = g_strTempXMLFile
    frm.Caption = strCaption
    frm.Show style
End Sub

Public Sub DisplayFile(ByVal strFileName As String, ByVal strCaption As String, Optional ByVal style As Integer = vbModeless)
    Dim frm As New frmXReport
    frm.m_bUsePath = True
    frm.m_strXML = ""
    frm.m_strPath = strFileName
    frm.Caption = strCaption
    frm.Show style
End Sub

