VERSION 5.00
Begin VB.Form frmComponentProfile 
   Caption         =   "Component Profile"
   ClientHeight    =   9405
   ClientLeft      =   5295
   ClientTop       =   3225
   ClientWidth     =   4575
   Icon            =   "frmComponentProfile.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   9405
   ScaleWidth      =   4575
   Begin VB.TextBox txtSingleLine 
      Height          =   315
      Index           =   0
      Left            =   240
      TabIndex        =   6
      Top             =   1350
      Visible         =   0   'False
      Width           =   3975
   End
   Begin VB.ComboBox cmbPickList 
      Height          =   315
      Index           =   0
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   2400
      Visible         =   0   'False
      Width           =   3975
   End
   Begin VB.CheckBox chkFlag 
      Height          =   315
      Index           =   0
      Left            =   240
      TabIndex        =   4
      Top             =   3120
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.CommandButton cmdDateClick 
      Caption         =   "l"
      BeginProperty Font 
         Name            =   "Wingdings"
         Size            =   8.25
         Charset         =   2
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Index           =   0
      Left            =   3900
      TabIndex        =   3
      Top             =   1380
      Visible         =   0   'False
      Width           =   255
   End
   Begin VB.ListBox List1 
      Height          =   840
      Index           =   0
      Left            =   240
      TabIndex        =   2
      Top             =   4080
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.CommandButton cmdOkay 
      Caption         =   "Ok"
      Height          =   405
      Left            =   3120
      TabIndex        =   1
      Top             =   30
      Width           =   1125
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   405
      Left            =   3120
      TabIndex        =   0
      Top             =   570
      Width           =   1125
   End
   Begin VB.Label LbSingleLine 
      AutoSize        =   -1  'True
      Caption         =   "LbSingleLine"
      Height          =   195
      Index           =   0
      Left            =   240
      TabIndex        =   9
      Top             =   1110
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.Label lblPickList 
      AutoSize        =   -1  'True
      Caption         =   "lblPickList"
      Height          =   195
      Index           =   0
      Left            =   240
      TabIndex        =   8
      Top             =   2160
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.Label lblMultiValue 
      AutoSize        =   -1  'True
      Caption         =   "lblMultiValue"
      Height          =   195
      Index           =   0
      Left            =   240
      TabIndex        =   7
      Top             =   3840
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "Options"
      Begin VB.Menu mnuProfiles 
         Caption         =   "Profiles"
      End
      Begin VB.Menu mnuDefaults 
         Caption         =   "Defaults"
      End
   End
End
Attribute VB_Name = "frmComponentProfile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim g_dx As Integer
Dim g_dy As Integer

Dim g_x As Integer
Dim g_y As Integer
Dim g_w As Integer
Dim g_h As Integer

Dim g_bMove As Boolean
Dim g_bHasDate As Boolean

Dim g_i As Integer
Dim g_pi As Integer
Dim g_ci As Integer
Dim g_mi As Integer

Public m_objDomDoc As DOMDocument
Public m_bOk As Boolean
Public m_strComponentID As String
Public m_strComponentDefID As String
Public m_nDefaultID As Long
Public m_nNewComponentID As Long
Public m_nAction As Integer

Private m_objFields As IXMLDOMNodeList

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub Form_Load()
On Error GoTo errHandler
    
    Select Case m_nAction
        Case ADD
        Case UPDATE
        Case VIEW
            cmdCancel.Visible = False
            cmdOkay.Caption = "Close"
    End Select
    m_bOk = False
    
    Set m_objFields = m_objDomDoc.selectNodes("Fields/Field")
    
    g_i = 1
    g_pi = 1
    g_ci = 1
    g_mi = 1
    
    AddControls
    
Exit Sub
errHandler:
    If HandleError Then Resume
End Sub

Private Sub cmdOkay_Click()
On Error GoTo errHandler
    
    Dim objDom As DOMDocument
    Dim objFields As IXMLDOMElement
    Dim objField As IXMLDOMElement
    Set objDom = New DOMDocument
    Set objFields = objDom.createElement("Fields")
    objDom.appendChild objFields
    
    Dim objCurrentField As IXMLDOMElement
    
    Dim objList As IXMLDOMNodeList
    Dim objItem As IXMLDOMElement
    
    Dim strValue As String
    Dim strLabelName As String
    Dim strValueName As String
    Dim strFlPlnCmpntAttrDefColNm As String
    Dim strComponentXML As String
    Dim nItemData As Long
    Dim nIndex As Integer
        
    Dim nFieldIndex As Long
    
    If m_nAction = VIEW Then
        Unload Me
        Exit Sub
    End If
    
    'Loop through all the Control arrays and retrieve the values for their corresponding Fields
    Dim i As Integer
    
    'Loop through Text Box controls
    For i = 1 To g_i - 1
        
        'Retrieve the value from the control and then create a new Field Element for this value
        nFieldIndex = txtSingleLine(i).Tag
        strValue = txtSingleLine(i).Text
        Set objCurrentField = m_objFields(nFieldIndex)
        strFlPlnCmpntAttrDefColNm = getAttribute(objCurrentField, "FlPlnCmpntAttrDefColNm")
        Set objField = objDom.createElement("Field")
        objField.setAttribute "FlPlnCmpntAttrDefColNm", strFlPlnCmpntAttrDefColNm
        objField.Text = strValue
        objFields.appendChild objField
    
        'Need to set the Component Definition ID if we do not already have it
        getComponentDefID objCurrentField, m_strComponentDefID
    
    Next i
    
    'Loop through the ComboBox controls
    For i = 1 To g_pi - 1
        
        'Get the xml Field element that corresponds to this control
        nFieldIndex = cmbPickList(i).Tag
        Set objCurrentField = m_objFields(nFieldIndex)
        
        'Get the Column name for this field
        strFlPlnCmpntAttrDefColNm = getAttribute(objCurrentField, "FlPlnCmpntAttrDefColNm")
        
        'Retrieve the value from the control and then create a new Field Element for this value
        nIndex = cmbPickList(i).ListIndex
        If nIndex = -1 Then
            strValue = ""
        Else
            nItemData = cmbPickList(i).ItemData(nIndex)
            If nItemData = -1 Then 'Picklist where the caption = the value
                strValue = cmbPickList(i).Text
            Else 'The data represents the value
                strValue = CStr(nItemData)
            End If
        End If
        Set objField = objDom.createElement("Field")
        objField.setAttribute "FlPlnCmpntAttrDefColNm", strFlPlnCmpntAttrDefColNm
        objField.Text = strValue
        objFields.appendChild objField
    
        'Need to set the Component Definition ID if we do not already have it
        getComponentDefID objCurrentField, m_strComponentDefID
    
    Next i
    
    'Loop through the CheckBox controls
    For i = 1 To g_ci - 1
        
        'Retrieve the value from the control and then create a new Field Element for this value
        nFieldIndex = chkFlag(i).Tag
        If chkFlag(i).Value <> 0 Then
            strValue = "1"
        Else
            strValue = "0"
        End If
        Set objCurrentField = m_objFields(nFieldIndex)
        strFlPlnCmpntAttrDefColNm = getAttribute(objCurrentField, "FlPlnCmpntAttrDefColNm")
        Set objField = objDom.createElement("Field")
        objField.setAttribute "FlPlnCmpntAttrDefColNm", strFlPlnCmpntAttrDefColNm
        objField.Text = strValue
        objFields.appendChild objField
        
        'Need to set the Component Definition ID if we do not already have it
        getComponentDefID objCurrentField, m_strComponentDefID
    
    Next i
    
    'Loop through the Multivalued controls
    For i = 1 To g_mi - 1
        'Need to set the Component Definition ID if we do not already have it
        getComponentDefID objCurrentField, m_strComponentDefID
    Next i
    
    m_bOk = True
    
    strComponentXML = objDom.xml
    
    Dim nFlPlnCmpntDefID As Long
    nFlPlnCmpntDefID = CLng(m_strComponentDefID)
    
    Select Case m_nAction
    
        Case UPDATE
            
            Select Case nFlPlnCmpntDefID
                Case ATTRIBUTE_DEFINITION ' = -2
                Case AUDIT_ENTRY ' = -17
                Case AUTO_CLASSIFY_RULE ' = -21
                Case CHARGE_OUT ' = -20
                Case CHARGE_OUT_HISTORY ' = -25
                Case DEFAULT ' = -6
                Case DISPOSAL_AUTHORITY ' = -15
                Case FILE_PLAN_COMPONENT ' = 0
                Case FILE_PLAN_COMPONENT_DEFINITION ' = -1
                Case FILE_PLAN_VIEW ' = -13
                Case GROUP ' = -4
                    g_objUserController.updateGroup m_strComponentID, strComponentXML
                Case HOST ' = -12
                    'NOTE AddHostID does not have a ComponentID param so we must make sure that the Fields XML contains the ID
                    strComponentXML = AddHostID(strComponentXML, m_strComponentID)
                    g_objConfigurationController.updateHost strComponentXML
                Case LIFE_CYCLE_CODE ' = -10
                Case LIFE_CYCLE_CODE_PHASE ' = -18
                Case LIFE_CYCLE_PHASE ' = -9
                Case LOGIC_EXTENSION ' = -8
                Case PROFILE ' = -16
                Case RELATIONSHIP_DEFINITION ' = -5
                Case REPORT_LAYOUT ' = -23
                Case RESERVATION ' = -19
                Case ROLE ' = -26
                Case SAVED_QUERY ' = -24
                Case SUSPENSION ' = -14
                Case USER ' = -3
                    g_objUserController.updateUser m_strComponentID, strComponentXML
                Case Else
                    g_objFilePlanComponentController.updateFilePlanComponent m_strComponentID, strComponentXML, True
            End Select
        
        Case ADD
        
            If nFlPlnCmpntDefID > 0 Then
                m_nNewComponentID = g_objTemplateController.addNewFilePlanComponent(strComponentXML, _
                                                                                     m_strComponentDefID, _
                                                                                     m_strComponentID, _
                                                                                     m_nDefaultID)
            Else
            
            End If

    
    End Select
    
    Unload Me

Exit Sub
errHandler:
    If HandleError Then Resume
End Sub

'This method will add the controls to the Form
'If the Component has a custom Profile assigned to it
'then the controls will be drawn using the x,y co-ordinates
'otherwise they will simple be drawn from top to bottom
Private Sub AddControls()
    
    Dim gx As Integer
    Dim gy As Integer
    
    Dim i As Integer
    
    Dim strTemp As String
    
    Dim nType As Integer
    Dim strAttrDefColNm As String
    Dim strDatTypMaxLngth As String
    Dim strMultiValuedFlg As String
    Dim strPckLstID As String
    
    Dim strCaption As String
    Dim strControlType As String
    Dim strMandatory As String
    Dim strReadOnly As String
    Dim strTop As String
    Dim strLeft As String
    Dim strHeight As String
    Dim strWidth As String
    
    Dim nControlType As Integer
    Dim x As Integer
    Dim y As Integer
    
    Dim gMaxY As Integer
    gMaxY = 0
    Dim bIsCustom As Boolean
    bIsCustom = False
    
    
    Dim objField As IXMLDOMElement
    
    gy = LbSingleLine(0).Top
    gx = LbSingleLine(0).Left
    
    For i = 0 To m_objFields.length - 1
        
        If Not bIsCustom Then
            If gy > gMaxY Then
                gMaxY = gy
            End If
            If gy > Me.Height - 1500 Then
                gy = LbSingleLine(0).Top
                gx = gx + txtSingleLine(0).Width + 500
                Me.Width = Me.Width + txtSingleLine(0).Width + 500
            End If
        End If
        
        Set objField = m_objFields.Item(i)
                
        'Get the Standard Field attributes
        strDatTypMaxLngth = getAttribute(objField, "DatTypMaxLngth")
        strMultiValuedFlg = getAttribute(objField, "MultiValuedFlg")
        strAttrDefColNm = getAttribute(objField, "FlPlnCmpntAttrDefColNm")
        strPckLstID = getAttribute(objField, "PckLstID")
        
        'Not needed Now
        'strCaption = getAttribute(objField, "FlPlnCmpntAttrDefCapt")
        
        'Get the Profile Attributes added by the Template Controller
        strCaption = getAttribute(objField, "Caption", strCaption) 'Use default from standard attributes
        strControlType = getAttribute(objField, "ControlType")
        strMandatory = getAttribute(objField, "Mandatory")
        strReadOnly = getAttribute(objField, "ReadOnly")
        
        'Get Our custom attributes
        strTop = getAttribute(objField, "Top")
        strLeft = getAttribute(objField, "Left")
        
        Select Case strAttrDefColNm
            
            Case PROFILE_FORM_DIMENSIONS 'This field contains the custom field with the Profile Dimensions
                Me.Height = getAttribute(objField, "Height")
                Me.Width = getAttribute(objField, "Width")
                bIsCustom = True
            Case "Default_Options"
                'Used to draw Profile list
            Case "Profile_Options"
                'Used to draw Defaults list
            Case "RowVrsn"
                'Always returned should not draw it
            Case Else
                
                If strControlType = "" Then
                    Err.Raise vbObjectError + 1, "frmComponentProfile", "Fields XML does not contain ControlType attribute. Make sure that the correct TemplateController Options have been used"
                End If
                
                nControlType = CInt(strControlType)
                
                'If there is no profile for this component then we cannot use the position attributes
                If strTop = "" Then
                    y = gy
                Else
                    y = CInt(strTop)
                End If
                If strLeft = "" Then
                    x = gx
                Else
                    x = CInt(strLeft)
                End If
                
                strTemp = getAttribute(objField, "FlPlnCmpntAttrDefDatTyp")
                If strTemp <> "" Then
                    nType = CInt(strTemp)
                    
                    Select Case nType
                        Case CONST_BINARY
                            'Add Binary Control Here"
                        Case CONST_BOOLEAN
                            AddCheckBox x, y, i, objField.Text, strCaption
                            gy = gy + chkFlag(0).Height + VERT_CONTROL_SPACING
                        Case CONST_CLOB
                            'Add Clob Control Here"
                        Case CONST_DATE, CONST_DATETIME
                            AddTextControl x, y, i, objField.Text, strCaption, True
                            gy = gy + LbSingleLine(0).Height + txtSingleLine(0).Height + VERT_CONTROL_SPACING
                        Case CONST_DOUBLE, CONST_INTEGER, CONST_STRING
                            If strMultiValuedFlg <> "0" Then
                                AddMultiLine x, y, i, objField, strCaption
                                gy = gy + lblMultiValue(0).Height + List1(0).Height + VERT_CONTROL_SPACING
                            Else
                                Select Case nControlType
                                    Case DROPLIST
                                        AddComboBox strPckLstID, strAttrDefColNm, x, y, i, objField, strCaption
                                        gy = gy + lblPickList(0).Height + cmbPickList(0).Height + VERT_CONTROL_SPACING
                                    Case COMBOBOX
                                        AddComboBox strPckLstID, strAttrDefColNm, x, y, i, objField, strCaption, True
                                        gy = gy + lblPickList(0).Height + cmbPickList(0).Height + VERT_CONTROL_SPACING
                                    Case Else
                                        AddTextControl x, y, i, objField.Text, strCaption
                                        gy = gy + LbSingleLine(0).Height + txtSingleLine(0).Height + VERT_CONTROL_SPACING
                                End Select
                            End If
                    End Select
                End If
           End Select
    Next i
    If Not bIsCustom Then
         Me.Height = gMaxY + 1500
    End If
End Sub

Private Sub AddTextControl(x As Integer, _
                            y As Integer, _
                            ByVal i As Integer, _
                            ByVal strValue As String, _
                            ByVal strCaption As String, _
                            Optional ByVal bIsDate As Boolean = False)
    
    
    Load LbSingleLine(g_i)
    
    LbSingleLine(g_i).Top = y
    LbSingleLine(g_i).Left = x
    LbSingleLine(g_i).Caption = strCaption
    LbSingleLine(g_i).Visible = True
    
    Load cmdDateClick(g_i)
    cmdDateClick(g_i).Top = y + LbSingleLine(g_i).Height + g_datPlus
    If bIsDate Then
        cmdDateClick(g_i).Visible = True
    Else
        cmdDateClick(g_i).Visible = False
    End If
    
    Load txtSingleLine(g_i)
    
    txtSingleLine(g_i).Top = y + LbSingleLine(g_i).Height
    txtSingleLine(g_i).Left = x
    txtSingleLine(g_i).Visible = True
    txtSingleLine(g_i).Tag = i
    txtSingleLine(g_i).Text = strValue
    
    cmdDateClick(g_i).Left = txtSingleLine(g_i).Left + txtSingleLine(g_i).Width - cmdDateClick(g_i).Width
    
    g_i = g_i + 1

End Sub

Private Sub AddCheckBox(x As Integer, _
                            y As Integer, _
                            ByVal i As Integer, _
                            ByVal strValue As String, _
                            ByVal strCaption As String)

    
    Load chkFlag(g_ci)
    
    chkFlag(g_ci).Top = y
    chkFlag(g_ci).Left = x
    chkFlag(g_ci).Visible = True
    chkFlag(g_ci).Tag = i
    chkFlag(g_ci).Caption = strCaption
    If strValue = "0" Or strValue = "" Then
        chkFlag(g_ci).Value = 0
    Else
        chkFlag(g_ci).Value = 1
    End If
    
    g_ci = g_ci + 1

End Sub

Private Sub AddComboBox(ByVal strPckLstID As String, _
                            ByVal strAttrDefColNm As String, _
                            x As Integer, _
                            y As Integer, _
                            ByVal i As Integer, _
                            objField As IXMLDOMElement, _
                            ByVal strCaption As String, _
                            Optional ByVal bIsCombo As Boolean = False)
    
    Dim strTemp As String
    Dim strSelectedValue As String
    Dim nSelectedIndex As Integer
    Load lblPickList(g_pi)
    
    lblPickList(g_pi).Top = y
    lblPickList(g_pi).Left = x
    lblPickList(g_pi).Caption = strCaption
    lblPickList(g_pi).Visible = True
    
    Load cmbPickList(g_pi)
    
    cmbPickList(g_pi).Top = y + lblPickList(g_pi).Height
    cmbPickList(g_pi).Left = x
    cmbPickList(g_pi).Visible = True
    cmbPickList(g_pi).Tag = i
    
    If strPckLstID <> "" Then
        nSelectedIndex = -1
        strSelectedValue = objField.Text
    End If
    
    If bIsCombo Then
        'cmbPickList(g_pi).style = 0 'Can't assign to readonly do sumpthin else
    End If
    
    If objField.hasChildNodes Then
        
        Dim strPckLstEntVal As String
        Dim strLabelName As String
        Dim strValueName As String
        
        Dim j As Integer
        Dim objList As IXMLDOMNodeList 'PckLstEntVal
        Dim objItem As IXMLDOMElement
        Set objList = objField.selectNodes("List/Item")
        For j = 0 To objList.length - 1
            Set objItem = objList.Item(j)
            If strPckLstID <> "" Then
                strPckLstEntVal = getAttribute(objItem, "PckLstEntVal")
                cmbPickList(g_pi).AddItem strPckLstEntVal, j
                cmbPickList(g_pi).ItemData(j) = -1 'Indicates that the label is the value
                If strSelectedValue = strPckLstEntVal Then
                    nSelectedIndex = j
                End If
            Else
                'Get the Attribute Definition Column Name for the Label and Data values you want
                LabelAndValueNamesForColumnName strAttrDefColNm, strLabelName, strValueName
                
                'Check if there is an empty value associated with this Field
                strPckLstEntVal = ""
                If attributeExists(objItem, "PckLstEntVal", strPckLstEntVal) Then
                    cmbPickList(g_pi).AddItem strPckLstEntVal, j
                    cmbPickList(g_pi).ItemData(j) = -1 'Indicates that the label is the value
                Else
                    strTemp = getAttribute(objItem, strLabelName)
                    cmbPickList(g_pi).AddItem strTemp, j
                    strTemp = getAttribute(objItem, strValueName)
                    cmbPickList(g_pi).ItemData(j) = CLng(strTemp)
                End If
                strTemp = ""
                If attributeExists(objItem, "Selected", strTemp) Then
                    cmbPickList(g_pi).ListIndex = j
                End If
            End If
        Next j
        If strPckLstID <> "" Then
            If nSelectedIndex <> -1 Then
               cmbPickList(g_pi).ListIndex = nSelectedIndex
            Else
                If strSelectedValue <> "" Then
                    'This means there is a value for this Field but it is not in the PickList, we must add it
                    cmbPickList(g_pi).AddItem strSelectedValue, j
                    cmbPickList(g_pi).ItemData(j) = -1 'Indicates that the label is the value
                    cmbPickList(g_pi).ListIndex = j
                End If
            End If
        End If
    Else
        cmbPickList(g_pi).AddItem objField.Text, 0
        cmbPickList(g_pi).ItemData(0) = -1
    End If
    g_pi = g_pi + 1

End Sub

Private Sub AddMultiLine(x As Integer, _
                            y As Integer, _
                            ByVal i As Integer, _
                            objField As IXMLDOMElement, _
                            ByVal strCaption As String)
    
    Load lblMultiValue(g_mi)
    
    lblMultiValue(g_mi).Top = y
    lblMultiValue(g_mi).Left = x
    lblMultiValue(g_mi).Caption = strCaption
    lblMultiValue(g_mi).Visible = True
    
    Load List1(g_mi)
    
    List1(g_mi).Top = y + lblMultiValue(g_mi).Height
    List1(g_mi).Left = x
    List1(g_mi).Visible = True
    List1(g_mi).Tag = i
    'Need code to add value here
    
    g_mi = g_mi + 1

End Sub

Private Sub Form_Resize()
    cmdOkay.Left = Me.Width - cmdOkay.Width - 500
    cmdCancel.Left = Me.Width - cmdCancel.Width - 500
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''  Helpers
Private Sub getComponentDefID(obj As IXMLDOMElement, ByRef strComponentDefID As String)
    If strComponentDefID = "" Then
        strComponentDefID = getAttribute(obj, "FlPlnCmpntDefID")
    End If
End Sub

'Tests to see if an attribute exista if so the value is retrieved
Private Function attributeExists(obj As IXMLDOMElement, ByVal strAttr As String, ByRef strValue As String) As Boolean
    Dim objAttr As IXMLDOMAttribute
    Set objAttr = obj.getAttributeNode(strAttr)
    If objAttr Is Nothing Then
        attributeExists = False
    Else
        strValue = obj.getAttribute(strAttr)
        attributeExists = True
    End If
End Function

Private Function getAttribute(obj As IXMLDOMElement, ByVal strAttr As String, Optional ByVal strDefault As String = "") As String
    Dim objAttr As IXMLDOMAttribute
    Set objAttr = obj.getAttributeNode(strAttr)
    If Not objAttr Is Nothing Then
        getAttribute = obj.getAttribute(strAttr)
    Else
        getAttribute = strDefault
    End If
End Function

Private Sub LabelAndValueNamesForColumnName(ByVal strColumnName As String, ByRef strLabelName As String, ByRef strValueName As String)

    Select Case strColumnName
        Case "DsplAthrtyID"
            strLabelName = "DsplAthrtyCd"
            strValueName = "DsplAthrtyID"
        Case "RecHsID"
            strLabelName = "RecHsNm"
            strValueName = "RecHsID"
        Case "LfCclCdID"
            strLabelName = "LfCclCdNm"
            strValueName = "LfCclCdID"
        Case "LfCclPhsID"
            strLabelName = "LfCclPhsNm"
            strValueName = "LfCclPhsID"
        Case "LfCclSpsnID"
            strLabelName = "LfCclSpsnNm"
            strValueName = "LfCclSpsnID"
        Case Else
            strLabelName = ""
            strValueName = ""
    End Select

End Sub

Private Function AddHostID(ByVal strComponentXML As String, ByVal strHostID As String) As String
    Dim objFields As IXMLDOMElement
    Dim objField As IXMLDOMElement
    Dim objDom As New DOMDocument
    objDom.async = False
    AddHostID = strComponentXML
    If objDom.LoadXml(strComponentXML) Then
        Set objFields = objDom.selectSingleNode("Fields")
        Set objField = objFields.selectSingleNode("/Field[@FlPlnCmpntAttrDefColNm='RecHsID']")
        If objField Is Nothing Then
            Set objField = objDom.createElement("Field")
            objField.setAttribute "FlPlnCmpntAttrDefColNm", "RecHsID"
            objField.Text = strHostID
            objFields.appendChild objField
            AddHostID = objDom.xml
        End If
    Else
        MsgBox objDom.parseError.reason
    End If
End Function
