VERSION 5.00
Begin VB.Form frmHostList 
   Caption         =   "Select Record Host"
   ClientHeight    =   2100
   ClientLeft      =   5820
   ClientTop       =   4590
   ClientWidth     =   5925
   LinkTopic       =   "Form1"
   ScaleHeight     =   2100
   ScaleWidth      =   5925
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4560
      TabIndex        =   2
      Top             =   660
      Width           =   1215
   End
   Begin VB.CommandButton cmdOkay 
      Caption         =   "OK"
      Height          =   375
      Left            =   4560
      TabIndex        =   1
      Top             =   150
      Width           =   1215
   End
   Begin VB.ComboBox comboHostList 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   150
      Width           =   4275
   End
End
Attribute VB_Name = "frmHostList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public m_nHostID As String
Public m_bOk As Boolean

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOkay_Click()
    m_bOk = True
    m_nHostID = comboHostList.ItemData(comboHostList.ListIndex)
    Unload Me
End Sub

Private Sub Form_Load()
On Error GoTo errHandler
    
    Dim strHostList As String
    Dim objDom As New DOMDocument
    Dim objList As IXMLDOMNodeList
    Dim objItem As IXMLDOMElement
    Dim i As Long
    
    m_bOk = False
    objDom.async = False
    
    strHostList = g_objConfigurationController.getHostList
    If objDom.LoadXml(strHostList) Then
        Set objList = objDom.selectNodes("List/Item")
        For i = 0 To objList.length - 1
            Set objItem = objList.Item(i)
            comboHostList.AddItem objItem.getAttribute("RecHsNm"), i
            comboHostList.ItemData(i) = CLng(objItem.getAttribute("RecHsID"))
        Next i
        comboHostList.ListIndex = 0
    Else
        MsgBox objDom.parseError.reason
    End If

Exit Sub
errHandler:
    If HandleError Then Resume
End Sub
