VERSION 5.00
Begin VB.Form frmProfile2 
   Caption         =   "Profile"
   ClientHeight    =   7155
   ClientLeft      =   2580
   ClientTop       =   4545
   ClientWidth     =   11760
   Icon            =   "frmProfile.frx":0000
   LinkTopic       =   "Form2"
   ScaleHeight     =   7155
   ScaleWidth      =   11760
   Begin VB.Frame Frame1 
      Caption         =   "Component Attribute Definition Column Name "
      Height          =   6975
      Left            =   60
      TabIndex        =   10
      Top             =   150
      Width           =   3795
      Begin VB.CommandButton cmdRemove 
         Caption         =   "Remove"
         Height          =   405
         Left            =   2430
         TabIndex        =   12
         Top             =   6390
         Width           =   1245
      End
      Begin VB.ListBox ListDefColName 
         Height          =   5910
         Left            =   150
         Style           =   1  'Checkbox
         TabIndex        =   11
         Top             =   300
         Width           =   3495
      End
   End
   Begin VB.ListBox List1 
      Height          =   840
      Index           =   0
      Left            =   6000
      TabIndex        =   9
      Top             =   4620
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   405
      Left            =   10560
      TabIndex        =   6
      Top             =   570
      Width           =   1125
   End
   Begin VB.CommandButton cmdOkay 
      Caption         =   "Ok"
      Height          =   405
      Left            =   10560
      TabIndex        =   5
      Top             =   30
      Width           =   1125
   End
   Begin VB.CommandButton cmdDateClick 
      Caption         =   "l"
      BeginProperty Font 
         Name            =   "Wingdings"
         Size            =   8.25
         Charset         =   2
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Index           =   0
      Left            =   9660
      TabIndex        =   4
      Top             =   1920
      Visible         =   0   'False
      Width           =   255
   End
   Begin VB.CheckBox chkFlag 
      Height          =   315
      Index           =   0
      Left            =   6000
      TabIndex        =   3
      Top             =   3660
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.ComboBox cmbPickList 
      Height          =   315
      Index           =   0
      Left            =   6000
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   2940
      Visible         =   0   'False
      Width           =   3975
   End
   Begin VB.TextBox txtSingleLine 
      Height          =   315
      Index           =   0
      Left            =   6000
      TabIndex        =   1
      Top             =   1890
      Visible         =   0   'False
      Width           =   3975
   End
   Begin VB.Label lblMultiValue 
      AutoSize        =   -1  'True
      Caption         =   "lblMultiValue"
      Height          =   195
      Index           =   0
      Left            =   6000
      TabIndex        =   8
      Top             =   4380
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.Label lblPickList 
      AutoSize        =   -1  'True
      Caption         =   "lblPickList"
      Height          =   195
      Index           =   0
      Left            =   6000
      TabIndex        =   7
      Top             =   2700
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.Label LbSingleLine 
      AutoSize        =   -1  'True
      Caption         =   "LbSingleLine"
      Height          =   195
      Index           =   0
      Left            =   6000
      TabIndex        =   0
      Top             =   1650
      Visible         =   0   'False
      Width           =   4005
   End
   Begin VB.Menu mnuProfile 
      Caption         =   "Profile"
      Begin VB.Menu mnuProfileSave 
         Caption         =   "Save"
      End
      Begin VB.Menu mnuProfileSaveAs 
         Caption         =   "Save As ..."
      End
      Begin VB.Menu mnuSeperator 
         Caption         =   "-"
      End
      Begin VB.Menu mnuClose 
         Caption         =   "Close"
      End
   End
   Begin VB.Menu mnuControls 
      Caption         =   "Controls"
      Begin VB.Menu mnuControlsAdd 
         Caption         =   "Add"
      End
      Begin VB.Menu mnuControlsEdit 
         Caption         =   "Edit"
      End
      Begin VB.Menu mnuSeperaator2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuControlsRemove 
         Caption         =   "Remove"
      End
   End
End
Attribute VB_Name = "frmProfile2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim g_dx As Integer
Dim g_dy As Integer

Dim g_x As Integer
Dim g_y As Integer
Dim g_w As Integer
Dim g_h As Integer

Dim g_bMove As Boolean

Dim g_i As Integer
Dim g_pi As Integer
Dim g_ci As Integer
Dim g_mi As Integer

Dim m_strComponentDefinitionID As Long
Dim m_lFilePlanComponentID As Long

Dim m_objDom As DOMDocument
Dim m_objNodeList As IXMLDOMNodeList

Public m_bOk As Boolean
Public m_nProfileID As Long
Public m_strProfileName As String

Public Property Get ComponentDefinitionID() As String
    ComponentDefinitionID = m_strComponentDefinitionID
End Property

Public Property Let ComponentDefinitionID(ByVal strComponentDefinitionID As String)
    m_strComponentDefinitionID = strComponentDefinitionID
End Property

Private Sub cmdCancel_Click()
    m_bOk = False
    Unload Me
End Sub

Private Sub cmdDateClick_Click(Index As Integer)
    frmDatePicker.Show vbModal
    If frmDatePicker.m_strDate <> "" Then
        txtSingleLine(Index).Text = frmDatePicker.m_strDate
    End If
End Sub

Private Sub addControlElement(objDomDoc As DOMDocument, _
                                objProfile As IXMLDOMElement, _
                                ByVal strCaption As String, _
                                objControl As Control, _
                                ByVal labelTop As Integer, _
                                ByRef nOrder As Integer)
    
    Dim i As Integer
    i = objControl.Tag
    Dim objItem As IXMLDOMElement
    Set objItem = m_objNodeList(i)
    
    Dim obj As IXMLDOMElement
    Set obj = objDomDoc.createElement("Control")
    
    'These attributes are used by the IRM Profile Designer
    obj.setAttribute "FlPlnCmpntAttrDefColNm", objItem.getAttribute("FlPlnCmpntAttrDefColNm")
    obj.setAttribute "FlPlnCmpntAttrDefNo", objItem.getAttribute("FlPlnCmpntAttrDefNo")
    obj.setAttribute "PrflCtrlDsplyNm", strCaption
    obj.setAttribute "PrflCtrlTyp", "1"
    obj.setAttribute "PrflCtrlStyl", "0"
    obj.setAttribute "PrflCtrlOrd", nOrder
    nOrder = nOrder + 1
    
    'Custom attributes to determine Position
    Dim n
    n = objControl.Top
    obj.setAttribute "Top", labelTop
    obj.setAttribute "Left", objControl.Left - Frame1.Width 'Subtract the List area from the profile

    objProfile.appendChild obj
    
End Sub

Private Sub cmdOkay_Click()
    
On Error GoTo errHandler
    
    If g_i + g_pi + g_ci + g_mi = 4 Then
        MsgBox "No Controls selected!"
        Exit Sub
    End If
    
    m_strProfileName = InputBox("Enter the Name for this Profile", "Profile Name", "ProfileForComponentDefID[" & m_strComponentDefinitionID & "]")
    If Len(m_strProfileName) = 0 Then
        Exit Sub
    End If
    
    Dim strProfileCaption As String
    strProfileCaption = InputBox("Enter the Caption for this Profile", "Profile Caption", m_strProfileName)
    If Len(m_strProfileName) = 0 Then
        strProfileCaption = m_strProfileName
    End If
    
    'Create Fields
    Dim objField As IXMLDOMElement
    Dim objFields As IXMLDOMElement
    Dim objDomFields As DOMDocument
    Set objDomFields = New DOMDocument
    Set objFields = objDomFields.createElement("Fields")
    objDomFields.appendChild objFields
    
    'File Plan Component Def ID
    Set objField = objDomFields.createElement("Field")
    objField.setAttribute "FlPlnCmpntAttrDefColNm", "FlPlnCmpntDefID"
    objField.Text = m_strComponentDefinitionID
    objFields.appendChild objField
   
    'Profile Name
    Set objField = objDomFields.createElement("Field")
    objField.setAttribute "FlPlnCmpntAttrDefColNm", "FlPlnCmpntPrflDefNm"
    objField.Text = m_strProfileName
    objFields.appendChild objField
    
    'Profile Image
    Set objField = objDomFields.createElement("Field")
    objField.setAttribute "FlPlnCmpntAttrDefColNm", "PrflDefImage"
    
    Dim objProfile As IXMLDOMElement
    Dim objDomProfile As DOMDocument
    Set objDomProfile = New DOMDocument
    Set objProfile = objDomProfile.createElement("Profile")
    objProfile.setAttribute "FlPlnCmpntDefID", m_strComponentDefinitionID
    objProfile.setAttribute "PrflCptn", strProfileCaption
    
    objDomProfile.appendChild objProfile
    
    Dim nOrder As Integer
    nOrder = 0
    
    'Add the dimensions of the Form to a User Control
    Dim obj As IXMLDOMElement
    Set obj = objDomProfile.createElement("Control")
    obj.setAttribute "PrflCtrlTyp", BLANKLINE
    obj.setAttribute "FlPlnCmpntAttrDefColNm", PROFILE_FORM_DIMENSIONS
    obj.setAttribute "FlPlnCmpntAttrDefNo", "0"
    obj.setAttribute "PrflCtrlDsplyNm", "Do not Edit this Profile in IRM all custom control locations will be lost"
    obj.setAttribute "PrflCtrlStyl", "0"
    obj.setAttribute "PrflCtrlOrd", nOrder
    obj.setAttribute "FlPlnCmpntAttrDefDatTyp", "0"
    nOrder = nOrder + 1
    
    obj.setAttribute "Height", Me.Height
    obj.setAttribute "Width", Me.Width - Frame1.Width
    objProfile.appendChild obj
    
    'Add the Control elements
    Dim i As Integer
    For i = 1 To g_i - 1
        If cmdDateClick(i).Visible Then
            addControlElement objDomProfile, objProfile, LbSingleLine(i).Caption, txtSingleLine(i), LbSingleLine(i).Top, nOrder
        Else
            addControlElement objDomProfile, objProfile, LbSingleLine(i).Caption, txtSingleLine(i), LbSingleLine(i).Top, nOrder
        End If
    Next i
    
    For i = 1 To g_pi - 1
        addControlElement objDomProfile, objProfile, lblPickList(i).Caption, cmbPickList(i), lblPickList(i).Top, nOrder
    Next i
    
    For i = 1 To g_ci - 1
        addControlElement objDomProfile, objProfile, chkFlag(i).Caption, chkFlag(i), chkFlag(i).Top, nOrder
    Next i
    
    For i = 1 To g_mi - 1
        addControlElement objDomProfile, objProfile, lblMultiValue(i).Caption, List1(i), lblMultiValue(i).Top, nOrder
    Next i
    
    Dim objCData As IXMLDOMCDATASection
    Set objCData = objDomFields.createCDATASection(objDomProfile.xml)
    objField.appendChild objCData
    objFields.appendChild objField
    
    'DisplayXML objDomProfile.xml, "Profile Image", vbModal
    'DisplayXML objDomFields.xml, "Profile Fields", vbModal
    
    m_nProfileID = g_objComponentDesignController.addProfile(objDomFields.xml)
    
    
    Dim strXML As String
    strXML = "<List><Item UsrGrpID='" & g_strCurrentUserID & "' /></List>"

    g_objComponentDesignController.addProfileListForUserGroup m_nProfileID, strXML

    m_bOk = True
    Unload Me

Exit Sub

errHandler:
    If HandleError Then Resume
    
End Sub

Private Sub cmdRemove_Click()
    
    MsgBox "Add code to Hide controls that you wish to remove"
    
End Sub

Private Sub Form_Load()
On Error GoTo errHandler
    
    g_bMove = False
    g_i = 1
    g_pi = 1
    g_ci = 1
    g_mi = 1
    
    SetAttributeDefListXML
    
Exit Sub
errHandler:
    If HandleError Then Resume
End Sub

Private Sub Form_Resize()
    
    Dim nFramHeight As Integer
    
    nFramHeight = Me.Height - 870
    If nFramHeight < 1600 Then
        nFramHeight = 1600
    End If
    Frame1.Height = nFramHeight
    
    ListDefColName.Height = Frame1.Height - 1065
    cmdRemove.Top = Frame1.Top + Frame1.Height - 600
    
    
    cmdOkay.Left = Me.Width - cmdOkay.Width - 500
    cmdCancel.Left = Me.Width - cmdCancel.Width - 500
    
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'Code for working the AttributeDefinition List
    'TEST_CODE
    'If m_objDom.Load(App.Path & "\testGetAttributeDefinitionByCompDefID.xml") Then

Sub SetAttributeDefListXML(Optional ByVal bSelected As Boolean = False)

On Error GoTo errHandler

    Dim i As Integer
    Dim strAttributeDefListXML As String
    Dim strFlPlnCmpntAttrDefColNm As String
    Dim objItem As IXMLDOMElement
    
    strAttributeDefListXML = g_objDefinitionController.getAttributeDefinitionByCompDefID(m_strComponentDefinitionID)
    
    Set m_objDom = New DOMDocument
    If m_objDom.LoadXml(strAttributeDefListXML) Then
        Set m_objNodeList = m_objDom.selectNodes("List/Item")
        For i = 0 To m_objNodeList.length - 1
            Set objItem = m_objNodeList.Item(i)
            strFlPlnCmpntAttrDefColNm = objItem.getAttribute("FlPlnCmpntAttrDefColNm")
            ListDefColName.AddItem strFlPlnCmpntAttrDefColNm, i
            ListDefColName.ItemData(i) = 0 'This indicates that the control is not on the profile
        Next i
    Else
        MsgBox m_objDom.parseError.reason
    End If
Exit Sub
errHandler:
    If HandleError Then Resume
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'Code for Adding the controls

Private Sub mnuControlsAdd_Click()
    
    MsgBox "Not needed"
    'Set frmListPicker.m_objDom = m_objDom
    'frmListPicker.Show vbModal
    'AddSelectedControls
    
End Sub

Private Sub AddSelectedControls()
    Dim y As Integer
    Dim nType As Integer
    Dim strAttrDefColNm As String
    Dim strCaption As String
    Dim strMultiValuedFlg As String
    Dim strPckLstID As String
    Dim objItem As IXMLDOMElement
    Dim objAttrPick As IXMLDOMAttribute
    y = g_y
    
    Dim i As Integer
    For i = 0 To ListDefColName.ListCount - 1
        
        If ListDefColName.Selected(i) Then
        
            If ListDefColName.ItemData(i) = 0 Then 'There is no corresponding control
                Set objItem = m_objNodeList.Item(i)
                nType = CInt(objItem.getAttribute("FlPlnCmpntAttrDefDatTyp"))
                strAttrDefColNm = objItem.getAttribute("FlPlnCmpntAttrDefColNm")
                strCaption = objItem.getAttribute("FlPlnCmpntAttrDefCapt")
                strMultiValuedFlg = objItem.getAttribute("MultiValuedFlg")
                Set objAttrPick = objItem.getAttributeNode("PckLstId")
                If Not objAttrPick Is Nothing Then
                    strPckLstID = objItem.getAttribute("PckLstId")
                Else
                    strPckLstID = ""
                End If
                Select Case nType
                    Case CONST_BINARY
                        MsgBox "Add Binary Control Here"
                    Case CONST_BOOLEAN
                        AddCheckBox g_x, y, i, "0", strCaption
                        y = y + chkFlag(0).Height + VERT_CONTROL_SPACING
                    Case CONST_CLOB
                        MsgBox "Add Clob Control Here"
                    Case CONST_DATE, CONST_DATETIME
                        AddTextControl g_x, y, i, "", strCaption, True
                        y = y + LbSingleLine(0).Height + txtSingleLine(0).Height + VERT_CONTROL_SPACING
                    Case CONST_DOUBLE, CONST_INTEGER
                        Select Case strAttrDefColNm
                            Case "RecHsID", "DsplAthrtyID", "LfCclCdID", "LfCclSpsnID", "LfCclPhsID"
                                AddComboBox g_x, y, i, "", strCaption
                                y = y + lblPickList(0).Height + cmbPickList(0).Height + VERT_CONTROL_SPACING
                            Case Else
                                AddTextControl g_x, y, i, "", strCaption
                                y = y + LbSingleLine(0).Height + txtSingleLine(0).Height + VERT_CONTROL_SPACING
                        End Select
                        
                    Case CONST_STRING
                        If Len(strPckLstID) = 0 Then
                            AddTextControl g_x, y, i, "", strCaption
                            y = y + LbSingleLine(0).Height + txtSingleLine(0).Height + VERT_CONTROL_SPACING
                        Else
                            If strMultiValuedFlg <> "0" Then
                                AddMultiLine g_x, y, i, "", strCaption
                                y = y + lblMultiValue(0).Height + List1(0).Height + VERT_CONTROL_SPACING
                            Else
                                AddComboBox g_x, y, i, "", strCaption
                                y = y + lblPickList(0).Height + cmbPickList(0).Height + VERT_CONTROL_SPACING
                            End If
                        End If
                End Select
                ListDefColName.ItemData(i) = 1
            End If
        
        End If
    
    Next i
    'Next objItem
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 2 Then
        g_x = x
        g_y = y
        PopupMenu mnuControls, vbPopupMenuLeftAlign, x, y
        If MsgBox("Add Controls at this Position?", vbYesNo + vbQuestion) = vbYes Then
            AddSelectedControls
        End If
        
    End If
End Sub

Private Sub AddTextControl(x As Integer, _
                            y As Integer, _
                            ByVal i As Integer, _
                            ByVal strValue As String, _
                            ByVal strCaption As String, _
                            Optional ByVal bIsDate As Boolean = False)
    
    
    Load LbSingleLine(g_i)
    
    LbSingleLine(g_i).Top = y
    LbSingleLine(g_i).Left = x
    LbSingleLine(g_i).Caption = strCaption
    LbSingleLine(g_i).Visible = True
    
    Load cmdDateClick(g_i)
    cmdDateClick(g_i).Top = y + LbSingleLine(g_i).Height + g_datPlus
    If bIsDate Then
        cmdDateClick(g_i).Visible = True
    Else
        cmdDateClick(g_i).Visible = False
    End If
    
    Load txtSingleLine(g_i)
    
    txtSingleLine(g_i).Top = y + LbSingleLine(g_i).Height
    txtSingleLine(g_i).Left = x
    txtSingleLine(g_i).Visible = True
    txtSingleLine(g_i).Tag = i
    txtSingleLine(g_i).Text = strValue
    
    cmdDateClick(g_i).Left = txtSingleLine(g_i).Left + txtSingleLine(g_i).Width - cmdDateClick(g_i).Width
    
    g_i = g_i + 1

End Sub

Private Sub AddCheckBox(x As Integer, _
                            y As Integer, _
                            ByVal i As Integer, _
                            ByVal strValue As String, _
                            ByVal strCaption As String)

    
    Load chkFlag(g_ci)
    
    chkFlag(g_ci).Top = y
    chkFlag(g_ci).Left = x
    chkFlag(g_ci).Visible = True
    chkFlag(g_ci).Tag = i
    chkFlag(g_ci).Caption = strCaption
    If strValue = "0" Then
        chkFlag(g_ci).Value = 0
    Else
        chkFlag(g_ci).Value = 1
    End If
    
    g_ci = g_ci + 1

End Sub

Private Sub AddComboBox(x As Integer, _
                            y As Integer, _
                            ByVal i As Integer, _
                            ByVal strValue As String, _
                            ByVal strCaption As String)
    
    Load lblPickList(g_pi)
    
    lblPickList(g_pi).Top = y
    lblPickList(g_pi).Left = x
    lblPickList(g_pi).Caption = strCaption
    lblPickList(g_pi).Visible = True
    
    Load cmbPickList(g_pi)
    
    cmbPickList(g_pi).Top = y + lblPickList(g_pi).Height
    cmbPickList(g_pi).Left = x
    cmbPickList(g_pi).Visible = True
    cmbPickList(g_pi).Tag = i
    'Need code to add value here
    
    g_pi = g_pi + 1

End Sub

Private Sub AddMultiLine(x As Integer, _
                            y As Integer, _
                            ByVal i As Integer, _
                            ByVal strValue As String, _
                            ByVal strCaption As String)
    
    Load lblMultiValue(g_mi)
    
    lblMultiValue(g_mi).Top = y
    lblMultiValue(g_mi).Left = x
    lblMultiValue(g_mi).Caption = strCaption
    lblMultiValue(g_mi).Visible = True
    
    Load List1(g_mi)
    
    List1(g_mi).Top = y + lblMultiValue(g_mi).Height
    List1(g_mi).Left = x
    List1(g_mi).Visible = True
    List1(g_mi).Tag = i
    'Need code to add value here
    
    g_mi = g_mi + 1

End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'Code for moving the controls (simple and primative)

Private Sub LbSingleLine_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 1 Then
        g_bMove = True
        g_dx = x - LbSingleLine(Index).Left
        g_dy = y - LbSingleLine(Index).Top
    End If
End Sub

Private Sub LbSingleLine_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If g_bMove Then
        LbSingleLine(Index).Left = x - g_dx
        LbSingleLine(Index).Top = y - g_dy
        txtSingleLine(Index).Left = x - g_dx
        txtSingleLine(Index).Top = y - g_dy + LbSingleLine(Index).Height
        cmdDateClick(Index).Left = txtSingleLine(Index).Left + txtSingleLine(Index).Width - cmdDateClick(Index).Width
        cmdDateClick(Index).Top = y - g_dy + LbSingleLine(Index).Height + g_datPlus
    End If
End Sub

Private Sub LbSingleLine_MouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    g_bMove = False
End Sub

Private Sub lblPickList_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 1 Then
        g_bMove = True
        g_dx = x - lblPickList(Index).Left
        g_dy = y - lblPickList(Index).Top
    End If
End Sub

Private Sub lblPickList_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If g_bMove Then
        lblPickList(Index).Left = x - g_dx
        lblPickList(Index).Top = y - g_dy
        cmbPickList(Index).Left = x - g_dx
        cmbPickList(Index).Top = y - g_dy + lblPickList(Index).Height
    End If
End Sub

Private Sub lblPickList_MouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    g_bMove = False
End Sub

Private Sub chkFlag_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 1 Then
        g_bMove = True
        g_dx = x - chkFlag(Index).Left
        g_dy = y - chkFlag(Index).Top
    End If
End Sub

Private Sub chkFlag_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If g_bMove Then
        chkFlag(Index).Left = x - g_dx
        chkFlag(Index).Top = y - g_dy
    End If
End Sub

Private Sub chkFlag_MouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    g_bMove = False
End Sub

Private Sub lblMultiValue_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 1 Then
        g_bMove = True
        g_dx = x - lblMultiValue(Index).Left
        g_dy = y - lblMultiValue(Index).Top
    End If
End Sub

Private Sub lblMultiValue_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If g_bMove Then
        lblMultiValue(Index).Left = x - g_dx
        lblMultiValue(Index).Top = y - g_dy
        List1(Index).Left = x - g_dx
        List1(Index).Top = y - g_dy + lblMultiValue(Index).Height
    End If
End Sub

Private Sub lblMultiValue_MouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    g_bMove = False
End Sub
