VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHeaderHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
' Licensed Materials - Property of IBM
' "Restricted Materials of IBM"
' 5746-SM2
'   Copyright IBM Corp. 1999, 2003 All Rights Reserved.
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

Implements IHeaderHandler

Option Explicit

Public EJBKey As String

Private Const HEADER_ELEMENT_NAMESPACE As String = _
"http://ibm.com/SessionInfoHeader"
Private Const HEADER_ELEMENT_NAME As String = "EJBKey"
Private Const EJB_KEY_ELEMENT_NAME As String = "EJBKey"

Private Function IHeaderHandler_readHeader(ByVal par_Reader As MSSOAPLib30.ISoapReader, ByVal par_HeaderNode As MSXML2.IXMLDOMNode, ByVal par_Object As Object) As Boolean
    IHeaderHandler_readHeader = False
End Function

Private Function IHeaderHandler_WillWriteHeaders() As Boolean
    IHeaderHandler_WillWriteHeaders = True
End Function

Private Sub IHeaderHandler_writeHeaders( _
    ByVal pSerializer As SoapSerializer30, _
    ByVal pObject As Object)

    pSerializer.StartHeaderElement HEADER_ELEMENT_NAME, HEADER_ELEMENT_NAMESPACE
    pSerializer.StartElement EJB_KEY_ELEMENT_NAME
    pSerializer.WriteString EJBKey
    pSerializer.EndElement
    pSerializer.EndHeaderElement
    
End Sub



