VERSION 5.00
Begin VB.Form frmDialog 
   Caption         =   "Select a target"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Licensed Materials - Property of IBM
' "Restricted Materials of IBM"
' 5746-SM2
'   Copyright IBM Corp. 1999, 2003 All Rights Reserved.
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
Option Explicit
Private strAllowedTargetList As String
Dim WithEvents ctlOptionButton As VB.OptionButton
Attribute ctlOptionButton.VB_VarHelpID = -1
Dim WithEvents ctlCommandButton As VB.CommandButton
Attribute ctlCommandButton.VB_VarHelpID = -1

Private Sub ctlCommandButton_Click()
    On Error GoTo errhandler
    
    Dim strStructure As String
    Dim frmComponent As New frmComponent
    Set oFilePlanComponentController = CreateObject("MSSOAP.SoapClient30")
    objHeaderHandler.EJBKey = getFilePlanComponentControllerKey
    oFilePlanComponentController.MSSoapInit gstrWSDLLocation & "/FilePlanComponentControllerEJBService.wsdl", "FilePlanComponentControllerEJBService"
    Set oFilePlanComponentController.HeaderHandler = objHeaderHandler
    Dim objControl As Control
    Dim blnFound As Boolean
    blnFound = False
    For Each objControl In Me.Controls
        If objControl.Value = "True" And Left(objControl.Name, Len("ctlOptionButton")) = "ctlOptionButton" Then
            glDefinitionID = objControl.Tag
            blnFound = True
            Exit For
        End If
    Next
    If Not blnFound Then
        MsgBox ("Select file plan component definition of the prospective target.")
        Exit Sub
    End If
    strStructure = oFilePlanComponentController.getFilePlanComponentStructure(glDefinitionID)
    Set oFilePlanComponentController = Nothing
    
    Dim objDomDoc As DOMDocument
    Set objDomDoc = New DOMDocument
    
    Dim objElement As MSXML2.IXMLDOMElement

    frmComponent.txtComponent.Text = "<Fields>" + vbCrLf
    If (objDomDoc.loadXML(strStructure)) Then
        For Each objElement In objDomDoc.childNodes(1).childNodes
            If (objElement.getAttribute("FlPlnCmpntAttrDefColNm") <> "FlPlnCmpntID") Then
                frmComponent.txtComponent.Text = frmComponent.txtComponent + "<Field FlPlnCmpntAttrDefColNm=" + "'" + objElement.getAttribute("FlPlnCmpntAttrDefColNm") + "'></Field>" + vbCrLf
            End If
        Next
    End If
    frmComponent.txtComponent.Text = frmComponent.txtComponent.Text & "</Fields>"
    Unload Me
    frmComponent.Show 1, frmMain
    
    Exit Sub
errhandler:
    MsgBox (Err.Description)
End Sub
Private Sub Form_Load()
On Error GoTo errhandler
    blnAllowedTargets = False
    blnClick = False
    If gstrCompType = "F" Then
        Set oFilePlanComponentController = CreateObject("MSSOAP.SoapClient30")
        objHeaderHandler.EJBKey = getFilePlanComponentControllerKey
        oFilePlanComponentController.MSSoapInit gstrWSDLLocation & "/FilePlanComponentControllerEJBService.wsdl", "FilePlanComponentControllerEJBService"
        Set oFilePlanComponentController.HeaderHandler = objHeaderHandler
        strAllowedTargetList = oFilePlanComponentController.getAllowedTargetList(glID, -1)
    ElseIf gstrCompType = "V" Then
        Set oFilePlanDesignController = CreateObject("MSSOAP.SoapClient30")
        objHeaderHandler.EJBKey = strFilePlanDesignControllerKey
        oFilePlanDesignController.MSSoapInit gstrWSDLLocation & "/FilePlanDesignControllerEJBService.wsdl", "FilePlanDesignControllerEJBService"
        Set oFilePlanDesignController.HeaderHandler = objHeaderHandler
        strAllowedTargetList = oFilePlanDesignController.getAllowedComponentDefinitionTargetList(0, glID)
    End If
    
    Dim objDomDoc As DOMDocument
    Set objDomDoc = New DOMDocument
    
    Dim objElement As MSXML2.IXMLDOMElement
    
    If (objDomDoc.loadXML(strAllowedTargetList)) Then
        Dim lTop As Long
        lTop = 240
        For Each objElement In objDomDoc.childNodes(1).childNodes
            Set ctlOptionButton = Controls.Add("VB.OptionButton", _
                    "ctlOptionButton" + objElement.getAttribute("FlPlnCmpntDefTgtID"), Me)
            With ctlOptionButton
                .Caption = objElement.getAttribute("FlPlnCmpntDefNm")
                .Visible = True
                .Move 150, lTop, 3000
                .Value = False
                .Tag = objElement.getAttribute("FlPlnCmpntDefTgtID")
                lTop = lTop + 500
            End With
        Next
    End If
    If Controls.Count > 0 Then
        blnAllowedTargets = True
        Set ctlCommandButton = Controls.Add("VB.CommandButton", "cmdDone", Me)
        Dim frmComponent As New frmComponent
        With ctlCommandButton
            .Caption = "Done"
            .Visible = True
            .Move 150, lTop, 1000
        End With
        Me.Height = lTop + ctlCommandButton.Height + 800
        Me.Left = intX + 3000
        Me.Top = intY + Me.Height
    Else
        Unload Me
    End If
    
    Exit Sub
   
errhandler:
    MsgBox (Err.Description)
End Sub

