VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmMain 
   Caption         =   "IBM Records Manager Navigator"
   ClientHeight    =   5145
   ClientLeft      =   3165
   ClientTop       =   2040
   ClientWidth     =   5535
   LinkTopic       =   "Form1"
   ScaleHeight     =   5145
   ScaleWidth      =   5535
   Begin VB.CommandButton Command1 
      Caption         =   "Exit"
      Height          =   372
      Left            =   240
      TabIndex        =   2
      Top             =   4680
      Width           =   732
   End
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   4092
      Left            =   240
      TabIndex        =   0
      Top             =   480
      Width           =   5052
      _ExtentX        =   8916
      _ExtentY        =   7223
      _Version        =   393217
      Indentation     =   88
      Sorted          =   -1  'True
      Style           =   7
      ImageList       =   "imlSmallIcons"
      Appearance      =   1
   End
   Begin MSComctlLib.ImageList imlSmallIcons 
      Left            =   1800
      Top             =   4440
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   13
      ImageHeight     =   13
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   6
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":0000
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":00B8
            Key             =   "cylinder"
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":022A
            Key             =   "leaf"
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":039C
            Key             =   ""
         EndProperty
         BeginProperty ListImage5 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":0434
            Key             =   "smlBook"
         EndProperty
         BeginProperty ListImage6 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":06E6
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.Line Line2 
      BorderColor     =   &H00808080&
      BorderStyle     =   6  'Inside Solid
      X1              =   0
      X2              =   5520
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Label lblConnect 
      BorderStyle     =   1  'Fixed Single
      Height          =   252
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   5052
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00FFFFFF&
      BorderWidth     =   3
      Index           =   0
      X1              =   0
      X2              =   5520
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Menu File 
      Caption         =   "&File"
      Begin VB.Menu Options 
         Caption         =   "&Options"
         Enabled         =   0   'False
      End
      Begin VB.Menu Exit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu Help 
      Caption         =   "&Help"
      Begin VB.Menu About 
         Caption         =   "&About"
      End
   End
   Begin VB.Menu PopUp 
      Caption         =   "&PopUp"
      Visible         =   0   'False
      Begin VB.Menu Add 
         Caption         =   "&Add"
      End
      Begin VB.Menu Copy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu Properties 
         Caption         =   "&Properties"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --------------------------------------------------------------
'
' Licensed Materials - Property of IBM
' "Restricted Materials of IBM"
' 5746-SM2
'   Copyright IBM Corp. 1999, 2003 All Rights Reserved.
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
' --------------------------------------------------------------

Option Explicit
Private mNode As Node ' Module-level Node variable.

Private Sub About_Click()
    Dim fAbout As New frmAbout
    fAbout.Show
    
End Sub

Private Sub Add_Click()
    On Error GoTo errhandler:
    
    Dim oNode As Node
    Set oNode = TreeView1.SelectedItem
  
    GetTag oNode.Tag, gstrLoaded, gstrCompType, glID

    If gstrCompType = "V" Or gstrCompType = "F" Then
       Screen.MousePointer = vbDefault
       Dim frmDialog As frmDialog
       Set frmDialog = New frmDialog
       On Error Resume Next
       frmDialog.Show 1, Me
       On Error GoTo errhandler
       If Not blnAllowedTargets Then
           MsgBox ("Can not add a target to the selected component.")
           Exit Sub
       ElseIf blnClick Then
           If oNode.Expanded Then
               Dim oChildNode As Node
               Set oChildNode = fMainForm.TreeView1.Nodes.Add(TreeView1.SelectedItem.Index, tvwChild, , glAddTitle, "closed")
               oChildNode.Tag = "F" & "F" & glAdd
           Else
               Expand_Node
           End If
       End If
    End If

    Exit Sub
    
errhandler:
    MsgBox (Err.Description)
End Sub

Private Sub Command1_Click()
    Unload Me
    Exit Sub
    
errhandler:
    MsgBox (Err.Description)
End Sub
Private Sub Command2_Click()
    PopupMenu PopUp
End Sub

Private Sub Copy_Click()
    Dim oNode As Node
    Dim strFullPath As String
    Dim objElement As MSXML2.IXMLDOMElement
    Dim objXML As New MSXML2.DOMDocument
    
    On Error GoTo errhandler:
    ' get current node
    ' get id, viewid
    Set oNode = TreeView1.SelectedItem
    
    If oNode.Key = "ROOT" Then
        strFullPath = "//"
    Else
    
        GetTag oNode.Tag, gstrLoaded, gstrCompType, glID
    
        If gstrCompType = "V" Then
            strFullPath = "//" & oNode.Text
        Else
            Screen.MousePointer = vbHourglass
            Set oFilePlanComponentController = CreateObject("MSSOAP.SoapClient30")
            objHeaderHandler.EJBKey = getFilePlanComponentControllerKey
            oFilePlanComponentController.MSSoapInit gstrWSDLLocation & "/FilePlanComponentControllerEJBService.wsdl", "FilePlanComponentControllerEJBService"
            Set oFilePlanComponentController.HeaderHandler = objHeaderHandler
            strFullPath = oFilePlanComponentController.getFullPathByID(glID, -1)
            Screen.MousePointer = vbDefault

        End If
        
    End If
    
    Clipboard.SetText (strFullPath)
    Set oFilePlanComponentController = Nothing
    
    Exit Sub
    
errhandler:
    MsgBox (Err.Description)
    
End Sub

Private Sub Exit_Click()
    Command1_Click
End Sub
Private Sub Form_Resize()
    
    TreeView1.Width = fMainForm.Width - 576
    lblConnect.Width = fMainForm.Width - 576
    Line1(0).X2 = fMainForm.Width
    Line2.X2 = fMainForm.Width
    
    TreeView1.Height = fMainForm.Height - (1276 + TreeView1.Top)
    Command1.Top = TreeView1.Height + TreeView1.Top + 136
    
End Sub


Private Sub Properties_Click()
    
    Dim oNode As Node
    Dim dProperties As New dlgPoperties
    Dim strCaption As String

    Dim strFullPath As String
    Dim strXML As String
    Dim objElement As MSXML2.IXMLDOMElement
    Dim objXML As New MSXML2.DOMDocument
    On Error GoTo errhandler
    
    ' get current node
    ' get id, viewid
    Set oNode = TreeView1.SelectedItem
    
    If oNode.Key = "ROOT" Then
        strFullPath = "//"
    Else
    
        GetTag oNode.Tag, gstrLoaded, gstrCompType, glID
    
        If gstrCompType = "V" Then
            strFullPath = "//" & oNode.Text
        Else
        
            Screen.MousePointer = vbHourglass
           
            Set oFilePlanComponentController = CreateObject("MSSOAP.SoapClient30")
            objHeaderHandler.EJBKey = getFilePlanComponentControllerKey
            oFilePlanComponentController.MSSoapInit gstrWSDLLocation & "/FilePlanComponentControllerEJBService.wsdl", "FilePlanComponentControllerEJBService"
            Set oFilePlanComponentController.HeaderHandler = objHeaderHandler
            strFullPath = oFilePlanComponentController.getFullPathByID(glID, -1)
            Screen.MousePointer = vbDefault
        End If
        
    End If
    
    Screen.MousePointer = vbHourglass
    If gstrCompType <> "V" Then
        strXML = oFilePlanComponentController.getFilePlanComponentById(glID)
    End If
    If objXML.loadXML(strXML) Then
    
        For Each objElement In objXML.childNodes(1).childNodes
    
            strCaption = CStr(objElement.getAttribute("FlPlnCmpntAttrDefCapt"))
            dProperties.lstProperties.AddItem (strCaption & ":  " & objElement.Text)
            
         Next objElement
    End If
    Screen.MousePointer = vbDefault
    
    dProperties.Caption = "Properties: " & strFullPath
    dProperties.Show 1, Me

    Set oFilePlanComponentController = Nothing
    
    Exit Sub
    
errhandler:
    MsgBox (Err.Description)
    
End Sub


' when mouse is clicked on a node, update the address display bar to the
' fullpath of the node

Private Sub TreeView1_Click()
    Dim oFPC  As SoapClient30
    Dim strFullPath As String
    Dim oNode As Node
    Dim objElement As MSXML2.IXMLDOMElement
    Dim objXML As New MSXML2.DOMDocument
    On Error GoTo errhandler
    ' get current node
    ' get id, viewid
    Set oNode = TreeView1.SelectedItem
    If oNode.Key = "ROOT" Then
        strFullPath = "//"
    Else
    
        GetTag oNode.Tag, gstrLoaded, gstrCompType, glID
        If gstrCompType = "V" Then
            strFullPath = "//" & oNode.Text
        Else
            Screen.MousePointer = vbHourglass
            Set oFPC = CreateObject("MSSOAP.SoapClient30")
            objHeaderHandler.EJBKey = getFilePlanComponentControllerKey
            oFPC.MSSoapInit gstrWSDLLocation & "/FilePlanComponentControllerEJBService.wsdl", "FilePlanComponentControllerEJBService"
            Set oFPC.HeaderHandler = objHeaderHandler
            strFullPath = oFPC.getFullPathByID(glID, -1)
            Screen.MousePointer = vbDefault
        
        End If
        
    End If
    
    fMainForm.lblConnect.Caption = strFullPath
    Set oFPC = Nothing
    Exit Sub
    
errhandler:
    MsgBox (Err.Description)
    
End Sub

Private Sub TreeView1_Collapse(ByVal Node As MSComctlLib.Node)

    ' Collapse is called if:
    ' a) you click on [+] sign on open folder
    ' b) you doubleclick on a node that is expanded
    ' collapse takes care of collapsing the tree
    
    Node.Image = "closed"

End Sub

' this sub called when you doubleclick on a node
' if the node has already been "loaded" in, then we let the
' default handler take care of expanding the tree.
' if the node has not been "loaded" in yet, then we load all the siblings
' of this node into the treeview first and set the node to indicate it has been
' loaded.
 Private Sub TreeView1_DblClick()
    Expand_Node
    
End Sub

Public Sub Expand_Node()
    Dim oNode As Node
    Dim cNode As Node
    Dim i As Integer
    Dim oFPC As SoapClient30
    Dim objElement As MSXML2.IXMLDOMElement
    Dim strFpcId As String
    Dim strTitle As String

    Dim strXML As String
    Dim objXML As New MSXML2.DOMDocument
    Dim lTempID As Long
    Dim lChildCount As Long
    On Error GoTo errhandler
    
    ' DoubleClick is only useful if there are no nodes loaded in yet.
    ' expand and collapse will not be called until there are nodes
    ' beneath a parent node. So if the nodes have not been loaded in yet
    ' load them. NOTE: expand will be called after this.
    ' Node.Tag = True (already loaded in) or False (not yet)
    
   Set oNode = TreeView1.SelectedItem
   
    If oNode.Key = "ROOT" Then
        Exit Sub
    End If
    
   
   GetTag oNode.Tag, gstrLoaded, gstrCompType, glID
   
   If gstrLoaded = "F" Or gstrLoaded = "X" Then
        
            ' Does this node have a "placeholder" child node (used to display [+]?
            ' NOTE: only "F" (fpc) type nodes can have a placeholder node.
            If gstrLoaded = "X" Then
                ' remove placeholder
                TreeView1.Nodes.Remove (oNode.Child.Index)
                gstrLoaded = "F"
            End If
            
            'Is this a view?
            If gstrCompType = "V" Then
            
                Screen.MousePointer = vbHourglass
                Set oFPC = CreateObject("MSSOAP.SoapClient30")
                objHeaderHandler.EJBKey = getFilePlanComponentControllerKey
                oFPC.MSSoapInit gstrWSDLLocation & "/FilePlanComponentControllerEJBService.wsdl", "FilePlanComponentControllerEJBService"
                Set oFPC.HeaderHandler = objHeaderHandler
                strXML = oFPC.getTargetList(glID, 0, 0, 0)
                
                Screen.MousePointer = vbDefault

                
                If objXML.loadXML(strXML) Then
                     
                    For Each objElement In objXML.childNodes(1).childNodes
                        
                        strTitle = CStr(objElement.getAttribute("FlPlnCmpntTtl"))
                        strTitle = strTitle & " [" & (CStr(objElement.getAttribute("FlPlnCmpntNm"))) & "]"
                        Set mNode = fMainForm.TreeView1.Nodes.Add(TreeView1.SelectedItem.Index, tvwChild, , strTitle, "closed")
                        lTempID = CLng(objElement.getAttribute("FlPlnCmpntID"))
                        
                        lChildCount = CLng(objElement.getAttribute("HasTgt"))
                      
                        If lChildCount > 0 Then
                            ' this node has children
                            ' insert a dummy node beneath this one to force the [+] sign
                            ' mark the node as type "X"
                          
                            mNode.Tag = "X" & "F" & lTempID
                            Set cNode = fMainForm.TreeView1.Nodes.Add(mNode.Index, tvwChild, , "VOID", "closed")
                            cNode.Tag = "XX0"
                            
                        Else
                            mNode.Tag = "F" & "F" & lTempID
                        End If

'                       mNode.Tag = "F" & "F" & lTempID
                        mNode.Sorted = True
                        
                    Next objElement
                End If
            Else
                ' Not a view do a normal fetch of targets beneath the FPC
                Screen.MousePointer = vbHourglass
                Set oFPC = CreateObject("MSSOAP.SoapClient30")
                objHeaderHandler.EJBKey = getFilePlanComponentControllerKey
                oFPC.MSSoapInit gstrWSDLLocation & "/FilePlanComponentControllerEJBService.wsdl", "FilePlanComponentControllerEJBService"
                Set oFPC.HeaderHandler = objHeaderHandler
                               
                strXML = oFPC.getTargetList(glViewID, glID, 0, 0)
                
                Screen.MousePointer = vbDefault
                If objXML.loadXML(strXML) Then
                    For Each objElement In objXML.childNodes(1).childNodes
                        
                        strTitle = CStr(objElement.getAttribute("FlPlnCmpntTtl"))
                        strTitle = strTitle & "[" & (CStr(objElement.getAttribute("FlPlnCmpntNm"))) & "]"
                        
                        Set mNode = fMainForm.TreeView1.Nodes.Add(TreeView1.SelectedItem.Index, tvwChild, , strTitle, "closed")
                        lTempID = CLng(objElement.getAttribute("FlPlnCmpntID"))
                        lChildCount = CLng(objElement.getAttribute("HasTgt"))
                        
                        If lChildCount > 0 Then
                            ' this node has children
                            ' insert a dummy node beneath this one to force the [+] sign
                            ' mark the node as type "X"
                            
                            mNode.Tag = "X" & "F" & lTempID
                            Set cNode = fMainForm.TreeView1.Nodes.Add(mNode.Index, tvwChild, , "VOID", "closed")
                            cNode.Tag = "XX0"
                            
                        Else
                            mNode.Tag = "F" & "F" & lTempID
                        End If
                        
                        mNode.Sorted = True
                    
                    Next objElement
                End If
            End If


        oNode.Tag = "T" & gstrCompType & glID
        oNode.Expanded = True   ' this forces an "expand" event
    End If
    
    If gstrCompType = "V" Then
        glViewID = glID      ' set current view context
    End If
    
    Set oFPC = Nothing
    Exit Sub
    
errhandler:
    MsgBox (Err.Description)
    
End Sub

Private Sub TreeView1_Expand(ByVal Node As MSComctlLib.Node)

    On Error GoTo errhandler
    
    ' figure out a way to remove fake node before expand displays subtree
    ' automatically!
    Node.Image = "open"
    
    ' first make this node the selected one
    Node.Selected = True
    
    If Node.Key = "ROOT" Then
        Exit Sub
    End If

   GetTag Node.Tag, gstrLoaded, gstrCompType, glID
   
    ' Does this node have a "placeholder" child node (used to display [+]?
    ' NOTE: only "F" (fpc) type nodes can have a placeholder node.
    If gstrLoaded = "X" Then

        ' remove placeholder
        TreeView1.Nodes.Remove (Node.Child.Index)
        Node.Tag = "F" & gstrCompType & glID
    End If


    Expand_Node
   Exit Sub

errhandler:
    MsgBox (Err.Description)
    
End Sub

Private Sub TreeView1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

    If Button = vbRightButton Then
       intX = x
       intY = y
       PopupMenu PopUp
    End If
   
End Sub



